package org.processmining.plugins.gapAnalysis.presentation;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;

import org.deckfour.uitopia.api.event.TaskListener.InteractionResult;
import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.util.ui.widgets.ProMCheckComboBox;
import org.processmining.framework.util.ui.widgets.ProMComboBox;
import org.processmining.framework.util.ui.widgets.ProMPropertiesPanel;
import org.processmining.framework.util.ui.widgets.ProMTextField;
import org.processmining.plugins.gapAnalysis.ConstantValues;
import org.processmining.plugins.gapAnalysis.utility.Helper;

public class ConfigurationPanelWorker {
	JButton fileButton =  new JButton("Choose directory");
	JFileChooser chooser = new JFileChooser();
	ProMPropertiesPanel configurationPanel = new 
			ConfigurationPanel("Event Gap Analysis - Configuration");
	JLabel chosenDirectory = new JLabel();
	
	public HashMap<String, Object> prepareConfiguration(UIPluginContext context,
			String[] parameterNames, String[] parameterDesc, XLog log) {

		HashMap<String, Object> paramSet = new HashMap<String, Object>();
		ProMComboBox checkBox = null;
		Helper helper = new Helper();
		SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
		
		
		for(int i=0; i<parameterNames.length; i++) {
			if(parameterNames[i].equalsIgnoreCase(ConstantValues.paramName01startDate) ||
					parameterNames[i].equalsIgnoreCase(ConstantValues.paramName02endDate)) {
				ProMTextField textField = new ProMTextField();
				textField.setName(parameterNames[i]);
				if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName01startDate)) {
					
					//textField.setText("10-01-2012");
					
					textField.setText(sdf.format(helper.getEarliestTimestamp(log)));
				}
				if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName02endDate)) {
					//textField.setText("20-01-2012");
					textField.setText(sdf.format(helper.getLatestTimestamp(log)));
				}
				configurationPanel.addProperty(parameterDesc[i], textField);
				paramSet.put(parameterNames[i], textField);
			}
			ArrayList<String> eventAttributes=new ArrayList<String>();
			HashSet<String> transactionType = helper.getTransactionType(log);
			if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName03eventType)) {	
				if (transactionType.contains("schedule")) {
					eventAttributes.add("schedule");
				}
				if (transactionType.contains("assign")) {
					eventAttributes.add("assign");
				}
				if (transactionType.contains("start")) {
					eventAttributes.add("start");
				}
				if (transactionType.contains("complete")) {
					eventAttributes.add("complete");
				}
				//if (transactionType.contains("start") && transactionType.contains("complete")) {
				//	eventAttributes.add("start and complete");
				//}
				checkBox = new ProMComboBox(eventAttributes);
				configurationPanel.addProperty(parameterDesc[i], checkBox);
				paramSet.put(parameterNames[i], checkBox);
			}
			if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName04gapTypes)) {
				ArrayList<String> gapTypes=new ArrayList<String>();
				if (transactionType.size()>=1) {
					gapTypes.add(ConstantValues.caseGapTypeDesc);
					gapTypes.add(ConstantValues.resourceGapTypeDesc);
					gapTypes.add(ConstantValues.minimumGapTypeDesc);
					gapTypes.add(ConstantValues.caseResourceGapTypeDesc);
					gapTypes.add(ConstantValues.resourceCaseGapTypeDesc);
					//gapTypes.add(ConstantValues.resourceGroupGapTypeDesc);
				}

				if (transactionType.contains("start") && transactionType.contains("complete")) {
					gapTypes.add(ConstantValues.activityGapTypeDesc);
					gapTypes.add(ConstantValues.activityIdleGapTypeDesc);
				}
				if (transactionType.contains("assign") && transactionType.contains("complete")) {
					gapTypes.add(ConstantValues.taskGapTypeDesc);
					gapTypes.add(ConstantValues.minShelfGapTypeDesc);
					gapTypes.add(ConstantValues.assignmentIdleGapTypeDesc);
				}
				if (transactionType.contains("schedule") && transactionType.contains("complete")) {
					gapTypes.add(ConstantValues.sojournGapTypeDesc);
					gapTypes.add(ConstantValues.minLaunchGapTypeDesc);
					gapTypes.add(ConstantValues.scheduleIdleGapTypeDesc);
				}
				if (transactionType.contains("assign") && transactionType.contains("start")) {
					gapTypes.add(ConstantValues.shelfGapTypeDesc);
				}
				if (transactionType.contains("schedule") && transactionType.contains("assign")) {
					gapTypes.add(ConstantValues.assignmentGapTypeDesc);
				}
				if (transactionType.contains("schedule") && transactionType.contains("start")) {
					gapTypes.add(ConstantValues.launchGapTypeDesc);
				}
				ProMCheckComboBox checkBoxes = new ProMCheckComboBox(gapTypes);
				checkBoxes.addSelectedItems(gapTypes);
				configurationPanel.addProperty(parameterDesc[i], checkBoxes);
				paramSet.put(parameterNames[i], checkBoxes);
			}
			if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName05IgnoreDiffDate)) {
				JLabel theLabel = new JLabel("Include events with different dates");
				JCheckBox theCheckbox = new JCheckBox();
				configurationPanel.addProperty(parameterDesc[i], theCheckbox);
				paramSet.put(parameterNames[i], theCheckbox);
			}
			if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName06directory)) {
				fileButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						if (e.getSource() == fileButton) {
							chooser.setDialogTitle("Select the temporary directory");
							chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
							chooser.setAcceptAllFileFilterUsed(false);
							int returnVal = chooser.showOpenDialog(configurationPanel);
							if (returnVal == JFileChooser.APPROVE_OPTION) {
								chosenDirectory.setText(chooser.getSelectedFile().getAbsolutePath());
							}
						}
					}
				});
				configurationPanel.addProperty(parameterDesc[i], fileButton);
				configurationPanel.addProperty("Selected dir:", chosenDirectory);				
			}
		}	
		//test
		InteractionResult result = context.showConfiguration("Configuration", 
				configurationPanel);
		if (result == InteractionResult.CANCEL) {
			context.getFutureResult(0).cancel(true);
			return null;
		}	
		paramSet.put(ConstantValues.paramName06directory, chosenDirectory.getText());
		
		ConstantValues.setFilePath(chosenDirectory.getText().replace("\\", "\\\\"));
		System.out.println("The selected directory is: " + ConstantValues.getFilePath());
		return paramSet;

	}
	

}
