package org.processmining.plugins.gapAnalysis.presentation;

import java.io.File;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.plugins.gapAnalysis.presentation.mvc.Controller;
import org.processmining.plugins.gapAnalysis.presentation.mvc.GapViewer;

public class GapVisualizer {

	@Plugin(name = "Gaps Visualization", 
			parameterLabels = {"Gap File Names", "Gap Files"},
			returnTypes = GapViewer.class, 
			returnLabels = "Gaps Visualization", 
			userAccessible = false, 
			help = "Visualizes the dotted chart")
	@Visualizer(name = "Gaps Visualization")
	//public static Controller visualize(PluginContext context, HashMap<String, File> gapFiles) throws Exception {
	public static Controller visualize(PluginContext context, String[] fileNames, File[] files) throws Exception {
		GapViewer view = new GapViewer(context, fileNames, files);
		Controller controller = new Controller(fileNames, files, view);
		view.setVisible(true);
		return controller;
	}
}
