package org.processmining.plugins.gapAnalysis.presentation.mvc;

import java.awt.BorderLayout;
import java.io.File;
import java.util.HashMap;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;

import org.processmining.framework.plugin.PluginContext;


public class GapViewer extends JPanel  {
	
	OptionPanel optionPanel = null;
	JScrollPane graphPanel = null;
	JPanel graphCanvas = null;
	JSplitPane mainDisplay = null;
	HashMap<String, File> gapFiles=null;
	
	//public GapViewer(PluginContext context, HashMap<String, File> gapFiles) throws Exception {
	public GapViewer(PluginContext context, String[] fileNames, File[] files) throws Exception {
		this.gapFiles = new HashMap<String,File>();
		for(int i=0; i<fileNames.length; i++) {
			gapFiles.put(fileNames[i], files[i]);
			System.out.println("fileName:" + fileNames[i] + " , file is: " + files[i].toString());
		}
		initializeGUI(gapFiles);
		
		//this.gapFiles = gapFiles;
	}

	private void initializeGUI(HashMap<String, File> gapFiles) throws Exception {
		int height = getHeight() - this.getInsets().bottom - this.getInsets().top - 50;
		int width = getWidth() - this.getInsets().left - this.getInsets().right - 200;
		
		optionPanel = new OptionPanel(gapFiles);
		JPanel theOptionPanel = optionPanel.getOptionPanel();
		
		graphCanvas = new JPanel();
		graphCanvas.setLayout(new BorderLayout());
		
		//graphCanvas.setPreferredSize(new Dimension(2000,2000));

		mainDisplay = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, theOptionPanel, graphCanvas);
		mainDisplay.setDividerLocation(165);
		mainDisplay.setDividerSize(3);
		mainDisplay.setOneTouchExpandable(true);
		
		setLayout(new BorderLayout());
		this.add(mainDisplay, BorderLayout.CENTER);
		validate();
		this.repaint();
	}
	
	public OptionPanel getOptionPanel() {
		return this.optionPanel;
	}
	
	public HashMap<String, File> getModel() {
		return this.gapFiles;
	}
	
	public JPanel getGraphCanvas() {
		return this.graphCanvas;
	}
	
	public JScrollPane getGraphPanel() {
		return this.graphPanel;
	}


	
}
