package org.processmining.plugins.gapAnalysis.utility;

import java.util.Date;
import java.util.HashMap;

public class Event implements Comparable<Event> {
	private String caseID;
	private Date timestamp;
	private String activity;
	private String resource;
	private String resourceGroup;
	private String transition;
	private HashMap<String, String> eventAttributes;
	private Integer taskInstance;
	
	public Event() {
		caseID=new String();
		timestamp=new Date();
		activity=new String();
		transition=new String();
		resource=new String();
		resourceGroup=new String();
		taskInstance = new Integer(0);
		eventAttributes=new HashMap<String, String>();
	}
	
	public Event(String caseID, Date timestamp, String activity, Integer taskInstance, String resource,
			String resourceGroup, String transition, HashMap<String, String> eventAttributes) {
		this.caseID=caseID;
		this.timestamp = timestamp;
		this.activity = activity;
		this.taskInstance = taskInstance;
		this.resource = resource;
		this.resourceGroup = resourceGroup;
		this.transition=transition;
		this.eventAttributes = eventAttributes;
	}
	
	public Event(String caseID, Date timestamp, String activity, String resource,
			String resourceGroup, String transition, HashMap<String, String> eventAttributes) {
		this.caseID=caseID;
		this.timestamp = timestamp;
		this.activity = activity;
		//this.taskInstance = taskInstance;
		this.resource = resource;
		this.resourceGroup = resourceGroup;
		this.transition=transition;
		this.eventAttributes = eventAttributes;
	}
	
	public String getCaseID() {
		return caseID;
	}
	public void setCaseID(String caseID) {
		this.caseID = caseID;
	}
	public Date getTimestamp() {
		return timestamp;
	}
	public void setTimestamp(Date timestamp) {
		this.timestamp = timestamp;
	}
	public String getActivity() {
		return activity;
	}
	public void setActivity(String activity) {
		this.activity = activity;
	}
	public String getResource() {
		return resource;
	}
	public void setResource(String resource) {
		this.resource = resource;
	}
	public String getResourceGroup() {
		return resourceGroup;
	}
	public void setResourceGroup(String resourceGroup) {
		this.resourceGroup = resourceGroup;
	}
	public HashMap<String, String> getEventAttributes() {
		return eventAttributes;
	}
	public void setEventAttributes(HashMap<String, String> eventAttributes) {
		this.eventAttributes = eventAttributes;
	}
	public String getTransition() {
		return this.transition;
	}
	public void setTransition(String transition) {
		this.transition=transition;
	}
	@Override
	public int compareTo(Event o) {
		return this.timestamp.compareTo(o.getTimestamp());
	}
	
	
}
