package org.processmining.plugins.gapAnalysis.worker;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.plugins.gapAnalysis.ConstantValues;
import org.processmining.plugins.gapAnalysis.utility.Event;


public class TwoEventsGap {

	public HashMap<String, String> calculateGapTwoEvents(Event theEvent, String gapPath, UIPluginContext context,
			ArrayList<String> selectedGapTypes, Boolean ignoreDiffDatesEvents, FileWriter fw,
			HashMap<String, Integer> fileKeyPositionMap, String eventType,
			HashMap<String, Date> activityGap, HashMap<String, Date> taskGap,
			HashMap<String, Date> sojournGap, HashMap<String, Date> shelfGap, HashMap<String, Date> assignmentGap,
			HashMap<String, Date> launchGap,
			FileWriter activityGapWriter, FileWriter taskGapWriter, FileWriter sojournGapWriter,
			FileWriter shelfGapWriter, FileWriter assignmentGapWriter, FileWriter launchGapWriter,
			String[] perEventLine, HashMap<String, String> gapLineMap) throws IOException, Exception {
		
		String activityGapLine=null;
		String taskGapLine = null;
		String sojournGapLine=null;
		String shelfGapLine=null;
		String assignmentGapLine=null;
		String launchGapLine=null;
		//String transType = theEvent.getTransition();
		/*if (transType.equalsIgnoreCase("assign")) {
			System.out.println("found assign");
		}*/
		if (selectedGapTypes.contains(ConstantValues.activityGapType) &&
				(theEvent.getTransition().equalsIgnoreCase("complete") || 
						theEvent.getTransition().endsWith("start"))) {
			activityGapLine = populateDoubleGap(theEvent, activityGap, ConstantValues.activityGapType, perEventLine,
					fileKeyPositionMap, activityGapWriter, ignoreDiffDatesEvents);
			context.getProgress().inc();
		}
		if (selectedGapTypes.contains(ConstantValues.taskGapType) &&
				(theEvent.getTransition().equalsIgnoreCase("complete") || 
						theEvent.getTransition().endsWith("assign"))) {
			taskGapLine = populateDoubleGap(theEvent, taskGap, ConstantValues.taskGapType, perEventLine,
					fileKeyPositionMap, taskGapWriter, ignoreDiffDatesEvents);
			context.getProgress().inc();
		}
		if (selectedGapTypes.contains(ConstantValues.sojournGapType) &&
				(theEvent.getTransition().equalsIgnoreCase("complete") || 
						theEvent.getTransition().endsWith("schedule"))) {
			sojournGapLine = populateDoubleGap(theEvent, sojournGap, ConstantValues.sojournGapType, perEventLine,
					fileKeyPositionMap, sojournGapWriter, ignoreDiffDatesEvents);
			context.getProgress().inc();
		}
		if (selectedGapTypes.contains(ConstantValues.shelfGapType) &&
				(theEvent.getTransition().equalsIgnoreCase("start") || 
						theEvent.getTransition().equalsIgnoreCase("assign"))) {
			shelfGapLine = populateDoubleGap(theEvent, shelfGap, ConstantValues.shelfGapType, perEventLine,
					fileKeyPositionMap, shelfGapWriter, ignoreDiffDatesEvents);
			context.getProgress().inc();
			if (theEvent.getTransition().equalsIgnoreCase("assign")) {
				assert(false);
			}
		}
		if (selectedGapTypes.contains(ConstantValues.assignmentGapType) &&
				(theEvent.getTransition().equalsIgnoreCase("assign") || 
						theEvent.getTransition().endsWith("schedule"))) {
			assignmentGapLine = populateDoubleGap(theEvent, assignmentGap, ConstantValues.assignmentGapType, perEventLine,
					fileKeyPositionMap, assignmentGapWriter, ignoreDiffDatesEvents);
			context.getProgress().inc();
		}
		if (selectedGapTypes.contains(ConstantValues.launchGapType) &&
				(theEvent.getTransition().equalsIgnoreCase("start") || 
						theEvent.getTransition().endsWith("schedule"))) {
			launchGapLine = populateDoubleGap(theEvent, launchGap, ConstantValues.launchGapType, perEventLine,
					fileKeyPositionMap, launchGapWriter, ignoreDiffDatesEvents);
			context.getProgress().inc();
		}
		gapLineMap.put(ConstantValues.activityGapType, activityGapLine);
		gapLineMap.put(ConstantValues.taskGapType, taskGapLine);
		gapLineMap.put(ConstantValues.sojournGapType, sojournGapLine);
		gapLineMap.put(ConstantValues.shelfGapType, shelfGapLine);
		gapLineMap.put(ConstantValues.assignmentGapType, assignmentGapLine);
		gapLineMap.put(ConstantValues.launchGapType, launchGapLine);
		
		return gapLineMap;			
	}

	/*public String[] populateDoubleIdleGap(Event theEvent, HashMap<String, Date> idleGap, String idlegaptype,
			String[] perEventLine, HashMap<String, Integer> fileKeyPositionMap, FileWriter idleGapWriter,
			Boolean ignoreDiffDatesEvents, String eventType) {
		SimpleDateFormat printFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Date latestResourceDate=null;
		Date latestCaseDate = null;
		Date latestActivityDate = null;
		String theCase=null;
		String theResource=null;
		String theResourceGroup = theEvent.getResourceGroup();
		String theActivity = null;
		
		int gapPosition=0;
		Date theTime=null;
		//Make sure that the timestamp is not empty
		//If so, add the timestamp into the date collection
		try {
			theTime = theEvent.getTimestamp();
		} catch (NullPointerException e) {
			//if there is no timestamp, there is no point
			//adding this information into gap objects
			return perEventLine;
		}
		
		try {
			theCase = theEvent.getCaseID();
			theResource = theEvent.getResource();
			theActivity = theEvent.getActivity();
			gapPosition = fileKeyPositionMap.get(ConstantValues.idleGapType);
			//gapPositionResBusy = fileKeyPositionMap.get(ConstantValues.caseResourceGapText);
		} catch (NullPointerException e) {
			//The current event log does not contain
			//the key information for the particular gap analysis.
			//Simply put empty string to the gap type value
			System.out.println("Cannot find the key value for the gap analysis of type " + idlegaptype);
			perEventLine[gapPosition]="";
			return perEventLine;
		}
		
		
		//Ensure that the gap collection already contain the value 
		try {
			latestResourceDate = idleGap.get(theResource);
			latestCaseDate = idleGap.get(theCase);
			latestActivityDate = idleGap.get(theEvent.getCaseID()+":"+theEvent.getActivity()+":"+theEvent.getActivity()); 
		} catch (NullPointerException e) {
			//This should not happen because we have initiated the gap collection with all the possible keys
			e.printStackTrace();
		}
		
		//Now, check if there is both minimum gap or activity gap, w.r.t. current event 'theEvent'
		if (latestResourceDate==null ||  latestCaseDate == null) {
			if (theEvent.getTransition().equalsIgnoreCase("start")) {
				//So we see a start event, but without any preceding complete event
				//with the same resource or case ID.
				//We cannot calculate resourcebusy gap or case busy gap.
				//Thus, just ignore this event
			} else if (theEvent.getTransition().equalsIgnoreCase("complete")) {
				//Cannot calculate resource or case busy gap, hence update the gap collection object
				resourceCaseBusyGap.put(theCase, theTime);
				resourceCaseBusyGap.put(theResource, theTime);
			}
			perEventLine[gapPositionCaseBusy]="";
			perEventLine[gapPositionResBusy]="";
			return perEventLine;
		} else if (latestResourceDate!=null && latestCaseDate!=null) {
			if (theEvent.getTransition().equalsIgnoreCase("start")) {
				//We have found a gap
				long resDiff=0;
				long caseDiff=0;
				long caseBusyGap=0;
				long resBusyGap=0;
				
				if (latestResourceDate.before(theTime) || latestResourceDate.equals(theTime)) {
					resDiff=theTime.getTime() - latestResourceDate.getTime();
				}
				if (latestCaseDate.before(theTime) || latestCaseDate.equals(theTime)) {
					caseDiff = theTime.getTime() - latestCaseDate.getTime();
				}
				if (caseDiff>resDiff) {
					resBusyGap = latestResourceDate.getTime() - latestCaseDate.getTime() ;
					caseBusyGap = 0;
				} else if (caseDiff<resDiff) {
					resBusyGap=0;
					caseBusyGap = latestCaseDate.getTime() - latestResourceDate.getTime() ;
				} else if (caseDiff==resDiff) {
					caseBusyGap=0;
					resBusyGap=0;
				}
				perEventLine[gapPositionCaseBusy] = Long.toString(caseBusyGap);
				perEventLine[gapPositionResBusy] = Long.toString(resBusyGap);

				//Now, add the time and put it to file
				gapWriter.write(theCase+","+theActivity+","+
						theResource+","+theResourceGroup+","+
						theCase+","+theResource+","+printFormat.format(latestCaseDate)+","+
						printFormat.format(latestResourceDate) + "," +
						printFormat.format(theTime)+"\r\n");
				gapWriter.flush();
			} else if (theEvent.getTransition().equalsIgnoreCase("complete")){
				//Seems like we are dealing with resources who work parallelly
				//on multiple work items
				//Regardless, update the gap collection object according to the latest
				//complete timestamp that we see for the case and resource respectively
				resourceCaseBusyGap.put(theCase, theTime);
				resourceCaseBusyGap.put(theResource, theTime);
				perEventLine[gapPositionCaseBusy]="";
				perEventLine[gapPositionResBusy]="";
			}
			return perEventLine;
		}
		return perEventLine;
		
	}*/

	public HashMap<String, Date> prepareDoubleGapDataStructure(ArrayList<Event> allWithinEvents,
			String gapType) {
		HashMap<String, Date> gapDataStructure = new HashMap<String, Date>();
		Iterator<Event> eventIterator = allWithinEvents.iterator();
		while (eventIterator.hasNext()) {
			Event theEvent = eventIterator.next();
			//if (gapType.equalsIgnoreCase(ConstantValues.activityGapType)||
			
			String key = theEvent.getCaseID()+":"+theEvent.getActivity();
			gapDataStructure.put(key, null);
			//System.out.println("Test retrieving data structure is: " + gapDataStructure.get(key));
			//} else if (gapType.equalsIgnoreCase(ConstantValues.resourceGapType)) {
			//	String key = theEvent.getResource() +":"+ theEvent.getActivity();
			//	gapDataStructure.put(key, null);
			//} else if (gapType.equalsIgnoreCase(ConstantValues.resourceGroupGapType)) {
			//	String key = theEvent.getResourceGroup() +":"+ theEvent.getActivity();
			//	gapDataStructure.put(key, null);
			//} else if (gapType.equalsIgnoreCase(ConstantValues.resourceCaseBusyGapType) ||
			//		gapType.equalsIgnoreCase(ConstantValues.minimumGapType)) {
			//	String key1 = theEvent.getResource();
			//	gapDataStructure.put(key1, null);
			//	String key2 = theEvent.getCaseID();
			//	gapDataStructure.put(key2,null);
			//} else if (gapType.equalsIgnoreCase(ConstantValues.idleGapType)) {
			//	String key = theEvent.getCaseID()+":"+theEvent.getActivity()+":"+theEvent.getActivity();
			//	gapDataStructure.put(key, null);
			//	gapDataStructure.put(theEvent.getCaseID(), null);
			//	gapDataStructure.put(theEvent.getResource(), null);
			//}
		}
		//System.out.println("There are "+caseGap.size()+"-number of distinct case IDs");
		return gapDataStructure;
	}
	
	public String populateDoubleGap (Event theEvent,
			HashMap<String, Date> gapCollection, String theGapType, 
			String[] perEventLine, HashMap<String, Integer> fileKeyPositionMap,
			FileWriter gapWriter, Boolean ignoreDiffDatesEvents) throws Exception {
		SimpleDateFormat printFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
		Date latestGapDate=null;
		String theGapKey=null;
		int gapPosition=0;
		Date theTime=null;
		String gapLine=null;
		//String theCase = theEvent.getCaseID();
		//String theResource = theEvent.getResource();
		//String theResourceGroup = theEvent.getResourceGroup();
		//String theActivity = theEvent.getActivity();
		
		//Make sure that the timestamp is not empty
		//If so, add the timestamp into the date collection
		try {
			theTime = theEvent.getTimestamp();
		} catch (NullPointerException e) {
			//if there is no timestamp, there is no point
			//adding this information into gap objects
			return gapLine;
		}
		
		try {
			theGapKey = theEvent.getCaseID() +":" + theEvent.getActivity();
			perEventLine[fileKeyPositionMap.get(ConstantValues.caseID)] = theEvent.getCaseID();
			perEventLine[fileKeyPositionMap.get(ConstantValues.activity)] = theEvent.getActivity();
			if ( theGapType.equalsIgnoreCase(ConstantValues.activityGapType)) {
				gapPosition = fileKeyPositionMap.get(ConstantValues.activityGapType);
			} else if (theGapType.equalsIgnoreCase(ConstantValues.taskGapType)) {
				gapPosition = fileKeyPositionMap.get(ConstantValues.taskGapType); 
			} else if (theGapType.equalsIgnoreCase(ConstantValues.sojournGapType)) {
				gapPosition = fileKeyPositionMap.get(ConstantValues.sojournGapType);
			} else if ( theGapType.equalsIgnoreCase(ConstantValues.shelfGapType)) {
				gapPosition = fileKeyPositionMap.get(ConstantValues.shelfGapType);
			} else if ( theGapType.equalsIgnoreCase(ConstantValues.assignmentGapType)) {
				gapPosition = fileKeyPositionMap.get(ConstantValues.assignmentGapType);
			} else if ( theGapType.equalsIgnoreCase(ConstantValues.launchGapType)) {
				gapPosition = fileKeyPositionMap.get(ConstantValues.launchGapType);
			}
		} catch (NullPointerException e) {
			//The current event log does not contain
			//the key information for the particular gap analysis.
			//Simply put empty string to the gap type value
			System.out.println("Cannot find the key value for the gap analysis of type " + theGapType);
			perEventLine[gapPosition]="";
			return gapLine;
		}
		
		//Ensure that the gap collection already contain the value 
		try {
			//if ( !theGapType.equalsIgnoreCase(ConstantValues.minimumGapType)) {
			assert(gapCollection.containsKey(theGapKey));
			latestGapDate = gapCollection.get(theGapKey);
			System.out.println("the latest gap date for key:" + theGapKey+"is " + latestGapDate.toString());
			/*} else if (theGapType.equalsIgnoreCase(ConstantValues.minimumGapType)){
				String[] gapKey = new String[2];
				gapKey[0] = theEvent.getCaseID();
				gapKey[1] =  theEvent.getResource();
				latestGapDate = getResourceCaseLastDate(gapCollection, gapKey[0], gapKey[1]); 
			} */
		} catch (NullPointerException e) {
			//This should not happen because we have initiated the gap collection with all the possible keys
			latestGapDate = null;
			gapCollection.put(theGapKey, latestGapDate);
		}
		
		//Now, try to calculate the gap time
		String headType=null;
		String tailType=null;
		if (theGapType.equalsIgnoreCase(ConstantValues.activityGapType)) {
			headType="start";
			tailType="complete";
		} else if (theGapType.equalsIgnoreCase(ConstantValues.taskGapType)) {
			headType="assign";
			tailType="complete";
		} else if (theGapType.equalsIgnoreCase(ConstantValues.sojournGapType)) {
			headType="schedule";
			tailType="complete";
		} else if (theGapType.equalsIgnoreCase(ConstantValues.shelfGapType)) {
			headType="assign";
			tailType="start";
		} else if (theGapType.equalsIgnoreCase(ConstantValues.assignmentGapType)) {
			headType="schedule";
			tailType="assign";
		} else if (theGapType.equalsIgnoreCase(ConstantValues.launchGapType)) {
			headType="schedule";
			tailType="start";
		}
				
		gapLine = processNormalGap(theEvent, gapCollection, theGapType, headType, tailType, perEventLine, gapWriter, printFormat, latestGapDate,
					theGapKey, gapPosition, theTime, gapLine);
		/*else if (theGapType.equalsIgnoreCase(ConstantValues.minimumGapType)) {
			gapLine = processMinimalGap(theEvent, gapCollection, theGapType, perEventLine, gapWriter, printFormat, latestGapDate,
					theGapKey, gapPosition, theTime, gapLine);
		} */
			
		return gapLine;
	}

	private String processNormalGap(Event theEvent, HashMap<String, Date> gapCollection, String theGapType,
			String headType, String tailType, String[] perEventLine, FileWriter gapWriter, SimpleDateFormat printFormat, Date latestGapDate,
			String theGapKey, int gapPosition, Date theTime, String gapLine) throws IOException {
		if (latestGapDate == null) { 				
			if (theEvent.getTransition().equalsIgnoreCase(headType)) {
				//The very first entry for this type of gap value 
				gapCollection.put(theGapKey, theTime);
				Date testTime = gapCollection.get(theGapKey);
				System.out.println("The time stored is: " + testTime.toString());
			} else if (theEvent.getTransition().equalsIgnoreCase(tailType)){
				//we must have missed out on the related start event as latestGapDate is null
				// just ignore this event
			}
			perEventLine[gapPosition]="";
		} else {
			if (theEvent.getTransition().equalsIgnoreCase(headType)) {
				//an odd situation: we already have the start time of this work item, but
				//we see another start event for the same work item
				//probably an activity that can be repeated multiple times in parallel
				//In our approach, we assume that the work item must have been
				//completed, before a new one, same activity for the same case,
				//can be executed again. Thus, if the code reaches this point,
				//it means that, based on our assumption, that the same work item
				//must have been completed before and that we are dealign with
				//the start of a new work item of the same activity.
				//Thus, we override the existing start value in the gap map.
				gapCollection.put(theGapKey, theTime);
				perEventLine[gapPosition] = "";
			} else if (theEvent.getTransition().equalsIgnoreCase(tailType)) {
				//We have found a gap, we now calculate the gap duration.
				long diff=0;
				if (latestGapDate.before(theTime) || latestGapDate.equals(theTime)) {
					diff=theTime.getTime() - latestGapDate.getTime();
					perEventLine[gapPosition] = Long.toString(diff);
										
					//Since we have found a gap, add the time and put it to file
					gapLine = theEvent.getCaseID()+","+theEvent.getActivity()+","+
							theEvent.getResource()+","+theEvent.getResourceGroup()+","+
							theGapKey+","+
							printFormat.format(latestGapDate)+","+
							printFormat.format(theTime)+"\r\n";
					gapWriter.write(gapLine);
					gapWriter.flush();
				}
			}
		}
		return gapLine;
	}
		

	private String processMinimalGap(Event theEvent, HashMap<String, Date> gapCollection, String theGapType,
			String[] perEventLine, FileWriter gapWriter, SimpleDateFormat printFormat, Date latestGapDate,
			String theGapKey, int gapPosition, Date theTime, String gapLine) throws IOException {
		if (latestGapDate == null) { 				
			if (theEvent.getTransition().equalsIgnoreCase("start")) {
				// So we do not see any preceding complete event with the same case ID or 
				// with the same resource
				//so just ignore this event
				perEventLine[gapPosition] = "";
			} else if (theEvent.getTransition().equalsIgnoreCase("complete")) {
				//The very first entry for this type of gap value
				//add this key to the collection
				String[] keys = theGapKey.split(":");
				String caseID = keys[0];
				String resource=keys[1];
				gapCollection.put(caseID, theTime);
				gapCollection.put(resource,theTime);
			} 
			perEventLine[gapPosition] = "";
		} else {
			if (theEvent.getTransition().equalsIgnoreCase("start")){
				//we found a matching start event, hence do gap duration calculation
				long diff=0;
				if (latestGapDate.before(theTime) || latestGapDate.equals(theTime)) {
					diff=theTime.getTime() - latestGapDate.getTime();
					perEventLine[gapPosition] = Long.toString(diff);
										
					//Now, that we have found a gap, add the time and put it to file
					//For compatibility, need to separate the gap key into two words, not combined with ":"
					String[] keys = theGapKey.split(":");
					String caseID = keys[0];
					String resource=keys[1];
					gapLine = theEvent.getCaseID()+","+theEvent.getActivity()+","+
							theEvent.getResource()+","+theEvent.getResourceGroup()+","+
							caseID+","+resource+","+
							printFormat.format(latestGapDate)+","+
							printFormat.format(theTime)+"\r\n";
					gapWriter.write(gapLine);
					gapWriter.flush();
				}
			} else if (theEvent.getTransition().equalsIgnoreCase("complete")) {
				// seems like we are dealing with multuiple iterative work items
				// replace hte value with the previous one
				String[] keys = theGapKey.split(":");
				String caseID = keys[0];
				String resource=keys[1];
				gapCollection.put(caseID, theTime);
				gapCollection.put(resource,theTime);
				perEventLine[gapPosition] = "";
			}
		}
		return gapLine;
	}
	
	private String[] populateDoubleResourceCaseBusyGap (Event theEvent,
			HashMap<String, Date> resourceCaseBusyGap, String theGapType, 
			String[] perEventLine, HashMap<String, Integer> fileKeyPositionMap,
			FileWriter gapWriter,
			Boolean ignoreDiffDatesEvents) throws Exception {
		SimpleDateFormat printFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Date latestResourceDate=null;
		Date latestCaseDate = null;
		String theCase=null;
		String theResource=null;
		String theResourceGroup = theEvent.getResourceGroup();
		String theActivity = theEvent.getActivity();
		
		int gapPositionCaseBusy=0;
		int gapPositionResBusy=0;
		Date theTime=null;
		//Make sure that the timestamp is not empty
		//If so, add the timestamp into the date collection
		try {
			theTime = theEvent.getTimestamp();
		} catch (NullPointerException e) {
			//if there is no timestamp, there is no point
			//adding this information into gap objects
			return perEventLine;
		}
		
		try {
			theCase = theEvent.getCaseID();
			theResource = theEvent.getResource();
			gapPositionCaseBusy = fileKeyPositionMap.get(ConstantValues.resourceCaseGapText);
			gapPositionResBusy = fileKeyPositionMap.get(ConstantValues.caseResourceGapText);
		} catch (NullPointerException e) {
			//The current event log does not contain
			//the key information for the particular gap analysis.
			//Simply put empty string to the gap type value
			System.out.println("Cannot find the key value for the gap analysis of type " + theGapType);
			perEventLine[gapPositionCaseBusy]="";
			perEventLine[gapPositionResBusy]="";
			return perEventLine;
		}
		
		//Ensure that the gap collection already contain the value 
		try {
			latestResourceDate = resourceCaseBusyGap.get(theResource);
			latestCaseDate = resourceCaseBusyGap.get(theCase);
		} catch (NullPointerException e) {
			//This should not happen because we have initiated the gap collection with all the possible keys
			e.printStackTrace();
		}
		
		if (latestResourceDate==null ||  latestCaseDate == null) {
			if (theEvent.getTransition().equalsIgnoreCase("start")) {
				//So we see a start event, but without any preceding complete event
				//with the same resource or case ID.
				//We cannot calculate resourcebusy gap or case busy gap.
				//Thus, just ignore this event
			} else if (theEvent.getTransition().equalsIgnoreCase("complete")) {
				//Cannot calculate resource or case busy gap, hence update the gap collection object
				resourceCaseBusyGap.put(theCase, theTime);
				resourceCaseBusyGap.put(theResource, theTime);
			}
			perEventLine[gapPositionCaseBusy]="";
			perEventLine[gapPositionResBusy]="";
			return perEventLine;
		} else if (latestResourceDate!=null && latestCaseDate!=null) {
			if (theEvent.getTransition().equalsIgnoreCase("start")) {
				//We have found a gap
				long resDiff=0;
				long caseDiff=0;
				long caseBusyGap=0;
				long resBusyGap=0;
				
				if (latestResourceDate.before(theTime) || latestResourceDate.equals(theTime)) {
					resDiff=theTime.getTime() - latestResourceDate.getTime();
				}
				if (latestCaseDate.before(theTime) || latestCaseDate.equals(theTime)) {
					caseDiff = theTime.getTime() - latestCaseDate.getTime();
				}
				if (caseDiff>resDiff) {
					resBusyGap = latestResourceDate.getTime() - latestCaseDate.getTime() ;
					caseBusyGap = 0;
				} else if (caseDiff<resDiff) {
					resBusyGap=0;
					caseBusyGap = latestCaseDate.getTime() - latestResourceDate.getTime() ;
				} else if (caseDiff==resDiff) {
					caseBusyGap=0;
					resBusyGap=0;
				}
				perEventLine[gapPositionCaseBusy] = Long.toString(caseBusyGap);
				perEventLine[gapPositionResBusy] = Long.toString(resBusyGap);

				//Now, add the time and put it to file
				gapWriter.write(theCase+","+theActivity+","+
						theResource+","+theResourceGroup+","+
						theCase+","+theResource+","+printFormat.format(latestCaseDate)+","+
						printFormat.format(latestResourceDate) + "," +
						printFormat.format(theTime)+"\r\n");
				gapWriter.flush();
			} else if (theEvent.getTransition().equalsIgnoreCase("complete")){
				//Seems like we are dealing with resources who work parallelly
				//on multiple work items
				//Regardless, update the gap collection object according to the latest
				//complete timestamp that we see for the case and resource respectively
				resourceCaseBusyGap.put(theCase, theTime);
				resourceCaseBusyGap.put(theResource, theTime);
				perEventLine[gapPositionCaseBusy]="";
				perEventLine[gapPositionResBusy]="";
			}
			return perEventLine;
		}
		return perEventLine;
	}

	
	
	private Date getResourceCaseLastDate(HashMap<String, Date> theGapCollection,
			String theCaseID, String theResourceName) {
		Date lastCaseOrResourceDate=null;
		Date caseLastDate=null;
		Date resourceLastDate=null;
		try {
			caseLastDate = theGapCollection.get(theCaseID);
			resourceLastDate = theGapCollection.get(theResourceName);
			if (caseLastDate.after(resourceLastDate)) {
				lastCaseOrResourceDate = caseLastDate;
			} else if(resourceLastDate.after(caseLastDate)) {
				lastCaseOrResourceDate = resourceLastDate;
			} else if(resourceLastDate.equals(caseLastDate)) {
				lastCaseOrResourceDate = resourceLastDate;
			}
		} catch (NullPointerException e) {
			if (caseLastDate!=null) { 
				return caseLastDate;
			} else if(resourceLastDate!=null) {
				return resourceLastDate;
			} else {
				return null;
			}
		}
		return lastCaseOrResourceDate;
	}
	
	/*private HashMap<String, Date> prepareCaseGap(ArrayList<Event> allWithinEvents) {
		HashMap<String, Date> caseGap = new HashMap<String, Date>();
		Iterator<Event> eventIterator = allWithinEvents.iterator();
		while (eventIterator.hasNext()) {
			String caseID = eventIterator.next().getCaseID();
			caseGap.put(caseID, null);
		}
		System.out.println("There are "+caseGap.size()+"-number of distinct case IDs");
		return caseGap;
	}*/
	
	/*private HashMap<String, Date> prepareResourceGap(ArrayList<Event> allWithinEvents) {
		HashMap<String, Date> resourceGap = new HashMap<String, Date>();
		Iterator<Event> eventIterator = allWithinEvents.iterator();
		while (eventIterator.hasNext()) {
			String resourceName = eventIterator.next().getResource();
			resourceGap.put(resourceName, null);
		}
		System.out.println("There are "+resourceGap.size()+"-number of distinct resource IDs");
		return resourceGap;
	}*/
	
	/*private HashMap<String, Date> prepareActivityGap(ArrayList<Event> allWithinEvents) {
		HashMap<String, Date> activityGap = new HashMap<String,Date>();
		Iterator<Event> eventIterator = allWithinEvents.iterator();
		while (eventIterator.hasNext()) {
			String activityName=null;
			if ( (activityName = eventIterator.next().getActivity()) != null) {
				activityGap.put(activityName, null);	
			}
		}
		System.out.println("There are "+activityGap.size()+"-number of distinct activity IDs");
		return activityGap;
	}*/

	/*private HashMap<String, Date> prepareResourceGroupGap(ArrayList<Event> allWithinEvents) {
		HashMap<String, Date> resourceGroupGap = new HashMap<String,Date>();
		Iterator<Event> eventIterator = allWithinEvents.iterator();
		while (eventIterator.hasNext()) {
			String resourceGroupName = eventIterator.next().getResourceGroup();
			resourceGroupGap.put(resourceGroupName, null);
		}
		System.out.println("There are "+resourceGroupGap.size()+"-number of distinct resourceGroup IDs");
		return resourceGroupGap;
	}*/
	
	/*private HashMap<String, Date> prepareResourceCaseGap(ArrayList<Event> allWithinEvents) {
		HashMap<String, Date> caseResourceGap = new HashMap<String, Date>();
		Iterator<Event> eventIterator = allWithinEvents.iterator();
		while (eventIterator.hasNext()) {
			Event theEvent = eventIterator.next();
			String caseID = theEvent.getCaseID();
			String resourceName = theEvent.getResource();
			caseResourceGap.put(caseID, null);
			caseResourceGap.put(resourceName, null);
		}
		System.out.println("There are "+caseResourceGap.size()+"-number of distinct case-resource IDs");
		return caseResourceGap;
	}*/
	

	
	/*public void calculateEvolutionPerPointInTime(ArrayList<Event> allWithinEvents, long interval,
			String gapType, String filePath) throws Exception {
		Helper helper = new Helper();
		SimpleDateFormat printFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String fullPathName = filePath+"\\"+gapType+".csv";
		FileWriter fw = prepareIndividualGapFile(filePath, "evolution_perPointInTime_resourceGap.csv");
		HashMap<String, ArrayList<Date[]>> gapMap = getGapMap(fullPathName);	
		
		Date startDate = helper.getEarliestTimestamp(allWithinEvents);
		Date endDate= helper.getLatestTimestamp(allWithinEvents);
		Date refDate = new Date(startDate.getTime() + interval);
		
		while (refDate.before(endDate) || refDate.equals(endDate)) {
			Set<String> theKeySet = gapMap.keySet();
			Iterator<String> keyIterator = theKeySet.iterator();
			int gapPerPointInTime=0;
			while(keyIterator.hasNext()) {
				String theKey = keyIterator.next();
				ArrayList<Date[]> gapDatesPerKey = gapMap.get(theKey);
				Iterator<Date[]> gapDatesIterator = gapDatesPerKey.iterator();
				while(gapDatesIterator.hasNext()){
					Date[] dates = gapDatesIterator.next();
					Date date1 = dates[0];
					Date date2 = dates[1];
					//System.out.println("Ref date is: " + refDate);
					//System.out.println("Date range is: " + date1 + "," + date2);
					if ( (date1.before(refDate)||date1.equals(refDate)) &&
							(date2.after(refDate) || date2.equals(refDate)) ) {
						gapPerPointInTime++;
					}
				}
			}
			fw.write(printFormat.format(refDate)+","+gapPerPointInTime+"\r\n");
			refDate = new Date(refDate.getTime()+interval);
		}
		fw.close();		
		
	}*/
}
